#pragma semicolon 1
#include <sourcemod>
#include <cstrike>
#include <sdktools_functions>
#include <vip_core>

public Plugin:myinfo =
{
	name = "[VIP] Drop Weapons",
	author = "R1KO",
	version = "1.0.0"
};

#define VIP_DROP				"Drop"

new Handle:g_hGrensTrie;

new m_hActiveWeapon = -1,
	m_iAmmo = -1;

public VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(VIP_DROP, BOOL, HIDE);
}

public OnPluginStart()
{
	m_hActiveWeapon		= FindSendPropOffs("CCSPlayer",		"m_hActiveWeapon");
	m_iAmmo				= FindSendPropOffs("CBasePlayer",	"m_iAmmo");

	g_hGrensTrie = CreateTrie();
	SetTrieValue(g_hGrensTrie, "weapon_knife", -1);
	SetTrieValue(g_hGrensTrie, "weapon_hegrenade", 11);
	SetTrieValue(g_hGrensTrie, "weapon_flashbang", 12);
	SetTrieValue(g_hGrensTrie, "weapon_smokegrenade", 13);

	AddCommandListener(Command_Drop, "drop");
}

public Action:Command_Drop(iClient, const String:sCommand[], args)
{
	if (0 < iClient <= MaxClients && IsPlayerAlive(iClient) && VIP_IsClientVIP(iClient) && VIP_IsClientFeatureUse(iClient, VIP_DROP))
	{
		decl iWeapon, String:sWeapon[32];
		if(IsValidEntity((iWeapon = GetEntDataEnt2(iClient, m_hActiveWeapon))) && GetEntityClassname(iWeapon, sWeapon, sizeof(sWeapon)))
		{
			decl iOffs;
			if(GetTrieValue(g_hGrensTrie, sWeapon, iOffs))
			{
				if(iOffs == -1)
				{
					CS_DropWeapon(iClient, iWeapon, true, true);
					return Plugin_Handled;
				}

				iOffs = m_iAmmo + (iOffs*4);
				decl iCount;
				iCount = GetEntData(iClient, iOffs);
				CS_DropWeapon(iClient, iWeapon, true, true);

				if(iCount > 1)
				{
					iWeapon = GivePlayerItem(iClient, sWeapon);
					SetEntData(iClient, iOffs, iCount-1);
				//	SetEntPropEnt(iClient, Prop_Send, "m_hActiveWeapon", iWeapon);
					SetEntDataEnt2(iClient, m_hActiveWeapon, iWeapon, true);
				}
				return Plugin_Handled;
			}
		}
	}
	return Plugin_Continue;
}